import time
from PyQt5 import Qt
qt = Qt


class Runner(qt.QRunnable):
    def __init__(self, holder):
        qt.QRunnable.__init__(self)
        self.__holder = holder

    def run(self):
        try:
            print("STARTED")
            time.sleep(1)
        finally:
            print("FINISHED")
            self.__holder.finished.emit()

class Worker(qt.QObject):
    finished = qt.pyqtSignal()
    def __init__(self):
        qt.QObject.__init__(self)
        self.taskCount = 0
        self.finished.connect(self.__finished)

    def execute(self):
        self.taskCount += 1
        qt.QThreadPool.globalInstance().start(Runner(self))

    def __finished(self):
        self.taskCount -= 1

def use_worker():
    worker = Worker()
    for _ in range(qt.QThreadPool.globalInstance().maxThreadCount() * 2):
        worker.execute()

qapp = qt.QApplication([])
use_worker()
print("END")

